subroutine VARFevd(matrix Fcomp, matrix invAirf, sym sigma)

	'Compute the multipliers
	'===============================================
	matrix invAmult = @identity(!nvar)
	vector(!nvar) cumulfevd = 0
	'call VARir(Fcomp,invAmult,cumulfevd)

	for !mm=1 to !nvar

		'Initialize the impulse response vector
		matrix(!nvar,!nsteps) invAmult{!mm} = 0
		
		'Create the impulse vector
		matrix(!nvar,1) impulse = 0
  			
		'Set the size of the shock
		impulse(!mm,1) = 1 ' one stdev shock
		
		'First period impulse response (=impulse vector)
		matrix temp = invAmult*impulse
		matplace(invAmult{!mm},temp,1,1)
		
		'Make it comparable with companion
		vector(!nvar*!nlag) impulse_big = 0
		matplace(impulse_big,temp,1,1)
		
		'Recursive computation of impulse response
		matrix Fcomp_eye = @identity(!nvar*!nlag)
		
		for !kk = 2 to !nsteps
  			Fcomp_eye = Fcomp_eye * Fcomp
   			vector(!nvar*!nlag) irf_big{!kk} = Fcomp_eye * impulse_big
  			for !rr = 1 to !nvar
  					invAmult{!mm}(!rr,!kk) = irf_big{!kk}(!rr)
				next
		next
		
		delete irf_big*

		for !rr = 1 to !nvar
			if cumul(!rr)=1 then
				for !kk =1 to !nsteps
					if !kk =1 then
						invAmult{!mm}(!rr,!kk) = invAmult{!mm}(!rr,!kk)
					else
						invAmult{!mm}(!rr,!kk) = invAmult{!mm}(!rr,!kk) + invAmult{!mm}(!rr,!kk-1) 
					endif
				next
			endif
		next

	next
	
	delete temp impulse_big impulse Fcomp_eye 

	'Calculate the contribution to the MSE for each shock (i.e, FEVD)

	for !mm=1 to !nvar
	
		matrix(!nvar,!nvar) PSI1 = @identity(!nvar)
		matrix(!nvar,!nvar) MSE1 = sigma
	
		for !kk = 2 to !nsteps
			!zz=!kk-1
		
			matrix(!nvar,!nvar) PSI{!kk} = 0
			matrix(!nvar,!nvar) MSE{!kk} = 0
			matrix(!nvar,!nvar) MSE_j{!kk} = 0
			
			for !ii=1 to !nvar
				matplace(PSI{!kk},@columnextract(invAmult{!ii},!kk),1,!ii)
			next
		
			MSE{!kk} = MSE{!zz} + PSI{!kk}*sigma*@transpose(PSI{!kk})
		
		next
		
		' Get the column of invA corresponding to the mm_th shock
		vector column = @columnextract(invAirf,!mm)
		
		' Compute the mean square error
		matrix(!nvar,!nvar) MSE_j1 = column*@transpose(column)
		
		for !kk = 2 to !nsteps
			!zz=!kk-1
			MSE_j{!kk} = MSE_j{!zz} + PSI{!kk}*(column*@transpose(column))*@transpose(PSI{!kk})
		next
		
		' Compute the Forecast Error Covariance Decomposition
		for !kk = 1 to !nsteps
			matrix FECD{!kk} = @ediv(MSE_j{!kk},MSE{!kk})
		next
		
		'Select only the variance terms
		for !nn = 1 to !nsteps
			for !ii = 1 to !nvar
				matrix(!nsteps,!nvar) FEVD{!ii}
				FEVD{!ii}(!nn,!mm) = FECD{!nn}(!ii,!ii)
				matplace(SE,@sqrt( @transpose(@getmaindiagonal(MSE{!nn}))),!nn,1)
			next
		next
	
	next

	delete fecd* mse* psi*

endsub

